;------------------------------------------------------------------------------
; SOLAR_OS x64 version
; Copyright 2001,2018 Bogdan Valentin Ontanu,
; All rights reserved.
; Address: Europe, Romania, Bucuresti, Bd. Eroilor Sanitari nr:73, ap:2
; web: www.oby.ro, email: bogdanontanu@yahoo.com, bogdan.ontanu@oby.ro
;------------------------------------------------------------------------------
.use64

;------------------------------------------------------
; File:   	hello_world.asm
; Brief:  	Hello World app
; Author:	Ontanu Bogdan
; Date:	  	25.05.2018
;------------------------------------------------------


;------------------------------------------------------
; Hello World Application
;------------------------------------------------------

.string
	app_hello_sz_caption	db	"Hello World",0
	app_hello_sz_msg	db	"Welcome to the Hello World Application!",0

.code


PROC App_Hello_On_Main STDCALL
	USES	rcx,rdx,rbx,rsi,rdi
	ARG	@@wnd_handle,@@wnd_action,@@wnd_param1,@@wnd_param2
	local	l_sctx
	
	invoke	Window_Get_Sctx,[@@wnd_handle]
	mov	[l_sctx],rax

	.IF [@@wnd_action] == ACT_PAINT
		;-------------------
		; Wnd:On_Paint
		;--------------------
		
		; proportional text, single line, char wrap, clipped
		invoke	Draw_Prop_Text,[@@wnd_handle],8,32,8,app_hello_sz_msg
		
	.ELSEIF [@@wnd_action] == ACT_LEFT_DOWN
		;-----------------------------------
		; Wnd:ON_Mouse_Left_Down :)
		; todo: add click code here
		;-----------------------------------
		
	.ELSEIF [@@wnd_action] == ACT_LEFT_UP
		;-----------------------------------
		; Wnd:ON_Mouse_Left_Up :)
		; todo: add click code here
		;-----------------------------------
		
	.ELSEIF [@@wnd_action] == ACT_KEY
		;-----------------------------------
		; Wnd:ON_Key :)
		; todo: add keyboard code here
		;-----------------------------------
		
	.ELSEIF [@@wnd_action] == ACT_CLOSE
		;---------------------------
		; Wnd:Destructor
		; todo:add code here
		;---------------------------
	.ENDIF

	;----------------------------------------
	; by convention you must return zero 
	; or the parent will terminate you
	;----------------------------------------
	xor	rax,rax
	ret
ENDP


PROC App_Hello_Init STDCALL
	USES	rcx,rdx,rbx,rsi,rdi
	LOCAL	@@wnd_handle
	
	;------------------------------------
	; Create Main App Window
	;------------------------------------
	mov	rax,FLAG_WND_ALPHA+FLAG_WND_MINI

	; center window on screen
	mov	rcx,[os_video_back_dx]
	shr	rcx,1
	sub	rcx,200
	
	mov	rdx,[os_video_back_dy]
	shr	rdx,1
	sub	rdx,64
	

	invoke	Window_Create,[desk_crt],132,105,400,128,rax,WND_TYPE_TOP
	mov	[@@wnd_handle],rax
	
	;-------------------------------
	; set callback and caption
	;-------------------------------
	invoke	Window_Set_Callback,[@@wnd_handle],OS_CALL_AFTER,App_Hello_On_Main
	invoke	Window_Set_Caption,[@@wnd_handle],app_hello_sz_caption
	
	;---------------------------------------
	; minimum resize values, are optional
	;---------------------------------------
	invoke	Window_Set_Property,[@@wnd_handle],SOL_WND.dx_min,64	
	invoke	Window_Set_Property,[@@wnd_handle],SOL_WND.dy_min,64

	ret
ENDP

